<template>
  <div class="switch-button">
    <div v-for="(o, i) in options" :key="i" :class="`option ${i === activeIndex ? 'active' : ''}`" @click="switchTo(i)">
      {{options[i]}}
    </div>
    <span class="background" :style="background"></span>
  </div>
</template>

<script>
export default {
  name: 'switch-button',
  data() {
    return {
      activeIndex: 0
    }
  },
  props: {
    options: {
      type: Array
    },
    setMode: {
      type: Function
    }
  },
  computed: {
    background() {
      const style = {
        borderTopLeftRadius: this.activeIndex === 0 ? '8px' : 0,
        borderBottomLeftRadius: this.activeIndex === 0 ? '8px' : 0,
        borderTopRightRadius: this.activeIndex === 1 ? '8px' : 0,
        borderBottomRightRadius: this.activeIndex === 1 ? '8px' : 0,
        left: 1 / this.options.length * 100 * this.activeIndex + '%'
      }

      return style
    },
    optionClass(i) {
      const isActive = this.activeIndex === i

      return `option ${isActive ? 'active' : ''}`
    }
  },
  methods: {
    switchTo(index) {
      this.activeIndex = index

      this.setMode(this.options[index])
    }
  }
}
</script>

<style lang="scss" scoped>
@import '../config.scss';

.background {
  display: block;
  position: absolute;
  width: 50%;
  height: 100%;
  background-color: $orange;
  pointer-events: none;
  transition: all .2s;
  z-index: 0;
}

.switch-button {
  margin-bottom: 16px;
  height: 44px;
  width: 100%;
  display: flex;
  position: relative;

  .option {
    z-index: 1;
    display: flex;
    justify-content: center;
    align-items: center;
    // background-color: $light-grey;
    border: 1px dashed $orange;
    text-transform: capitalize;
    color: $dark-grey;
    cursor: pointer;

    flex: 1;

    &:first-of-type {
      border-right: none;
      border-top-left-radius: 8px;
      border-bottom-left-radius: 8px;
    }

    &:last-of-type {
      border-left: none;
      border-top-right-radius: 8px;
      border-bottom-right-radius: 8px;
    }
    &.active {
      // background-color: $orange;
      color: $white;
    }
  }
}
</style>
